<?php

/*
Plugin Name: FluentChat Basic
Plugin URI: http://ncrafts.net/fluent-chat/
Description: Live chat plugin for WordPress. Feature-packed. Clean interface. Free for life.
Author: nCrafts
Author URI: http://ncrafts.net/
Version: 1.0.2
Text Domain: fluentchatbasic
Domain Path: /languages
*/

global $FluentChatBasic, $wpdb;
$FluentChatBasic['nameCamel'] = 'FluentChatBasic';
$FluentChatBasic['nameCamelProper'] = 'FluentChat Basic';
$FluentChatBasic['nameLower'] = 'fluentchatbasic';
$FluentChatBasic['nameLowerTables'] = 'fluentchat';
$FluentChatBasic['env'] = $_SERVER['HTTP_HOST'] == 'localhost' ? 'local' : 'live';
$FluentChatBasic['messagesTable'] = $wpdb->prefix.$FluentChatBasic['nameLowerTables'].'_messages';
$FluentChatBasic['chatsTable'] = $wpdb->prefix.$FluentChatBasic['nameLowerTables'].'_chats';
$FluentChatBasic['customersTable'] = $wpdb->prefix.$FluentChatBasic['nameLowerTables'].'_customers';
$FluentChatBasic['operatorsTable'] = $wpdb->prefix.$FluentChatBasic['nameLowerTables'].'_operators';
$FluentChatBasic['feedbackTable'] = $wpdb->prefix.$FluentChatBasic['nameLowerTables'].'_feedback';
$FluentChatBasic['cookieName'] = 'fluentchat_basic_id';

$FluentChatBasic['defaultSettings'] = array();
$FluentChatBasic['defaultSettings']['pollingInterval'] = 3;
$FluentChatBasic['defaultSettings']['showWidget'] = true;
$FluentChatBasic['defaultSettings']['showWidgetEverywhere'] = true;
$FluentChatBasic['defaultSettings']['showWidgetPages'] = array();
$FluentChatBasic['defaultSettings']['showWidgetPosts'] = array();
$FluentChatBasic['defaultSettings']['disableOffline'] = false;
$FluentChatBasic['defaultSettings']['allowUploads'] = true;
$FluentChatBasic['defaultSettings']['allowUploadsSize'] = 5;
$FluentChatBasic['defaultSettings']['allowScreenshot'] = true;
$FluentChatBasic['defaultSettings']['allowLocation'] = true;

$FluentChatBasic['defaultStyling'] = array();
$FluentChatBasic['defaultStyling']['fontSize'] = '15px';
$FluentChatBasic['defaultStyling']['height'] = '520px';
$FluentChatBasic['defaultStyling']['width'] = '300px';
$FluentChatBasic['defaultStyling']['themeColor'] = '#4488ee';
$FluentChatBasic['defaultStyling']['chatSound'] = 'default.wav';
$FluentChatBasic['defaultStyling']['backgroundType'] = 'color';
$FluentChatBasic['defaultStyling']['backgroundColor'] = '#fafafa';
$FluentChatBasic['defaultStyling']['chatIconType'] = 'default';
$FluentChatBasic['defaultStyling']['animations'] = true;
$FluentChatBasic['defaultStyling']['fontSmoothing'] = false;
$FluentChatBasic['defaultStyling']['customCSS'] = '';

$FluentChatBasic['defaultSettings']['sendSMS'] = 1;
$FluentChatBasic['defaultSettings']['sendSMSNumbers'][] = array('number'=>'9999999999', 'carrier'=>'[number]@T Mobile');
$FluentChatBasic['defaultSettings']['welcome'] = 1;
$FluentChatBasic['defaultSettings']['welcomeMessageDelay'] = 2;
$FluentChatBasic['defaultSettings']['welcomeOperator'] = 'Mark';
$FluentChatBasic['defaultSettings']['askEmail'] = 1;
$FluentChatBasic['defaultSettings']['askEmailAnimate'] = 'cloud';
$FluentChatBasic['defaultSettings']['startChatHeader'] = __("Let's get started", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['askEmailNameLabel'] = __("Name", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['askEmailEmailLabel'] = __("Email", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['startChatFooter'] = __("press Enter to start", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactForm'] = 0;
$FluentChatBasic['defaultSettings']['contactFormAnimate'] = __("cloud", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormHeader'] = __("All our operators are currently offline. Please leave us a message.", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormNameLabel'] = __("Name", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormEmailLabel'] = __("Email", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormMessageLabel'] = __("Message", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormSent'] = __("Thanks!\n\nWe have your inquiry. We will get back to you asap.", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormSubject'] = __("You have a new chat inquiry from [Name]", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['contactFormBody'] = __("New Live Chat Inquiry!\n\nName: [Name]\nEmail: [Email]\nMessage: [Message]", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['allowLogs'] = 1;
$FluentChatBasic['defaultSettings']['allowLogsLabel'] = __("Get Email Transcript", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['allowLogsSubject'] = __("Your Live Chat Transcript", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['askFeedback'] = 1;
$FluentChatBasic['defaultSettings']['askFeedbackMessage'] = __("Thanks for your feedback!", 'fluentchatbasic');
$FluentChatBasic['defaultSettings']['chatEndMessage'] = __("Chat Ended.\n\nFor further queries, please email us at:\r\n\r\nadmin@example.com", 'fluentchatbasic');

$FluentChatBasic['SMSCarriers'] = array();
$FluentChatBasic['SMSCarriers'][] = array('Name'=>'3 (UK)', 'Email'=>'[number]@three.co.uk');

function FluentChatBasic_OnInit() {
  global $FluentChatBasic;
  load_plugin_textdomain( 'fluentchatbasic', false, basename( dirname( __FILE__ ) ) . '/languages' );
  $FluentChatBasic['translate'] = array();
  $FluentChatBasic['translate']['John was super helpful. There was a small delay, but the issue was resolved to my satisfaction. I am so glad you guys have this FluentChat widget!'] = __('John was super helpful. There was a small delay, but the issue was resolved to my satisfaction. I am so glad you guys have this FluentChat widget!', 'fluentchatbasic');
  $FluentChatBasic['translate']['press Esc to close'] = __('press Esc to close', 'fluentchatbasic');
  $FluentChatBasic['translate']['Unlock Feature'] = __('Unlock Feature', 'fluentchatbasic');
  $FluentChatBasic['translate']['Archived Chats'] = __('Archived Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['showing'] = __('showing', 'fluentchatbasic');
  $FluentChatBasic['translate']['Search...'] = __('Search...', 'fluentchatbasic');
  $FluentChatBasic['translate']['All Operators'] = __('All Operators', 'fluentchatbasic');
  $FluentChatBasic['translate']['not assigned'] = __('not assigned', 'fluentchatbasic');
  $FluentChatBasic['translate']['No Results'] = __('No Results', 'fluentchatbasic');
  $FluentChatBasic['translate']['No Active Chat'] = __('No Active Chat', 'fluentchatbasic');
  $FluentChatBasic['translate']['total messages'] = __('total messages', 'fluentchatbasic');
  $FluentChatBasic['translate']['chatting since'] = __('chatting since', 'fluentchatbasic');
  $FluentChatBasic['translate']['last message'] = __('last message', 'fluentchatbasic');
  $FluentChatBasic['translate']['today'] = __('today', 'fluentchatbasic');
  $FluentChatBasic['translate']['Customer Info'] = __('Customer Info', 'fluentchatbasic');
  $FluentChatBasic['translate']['Name'] = __('Name', 'fluentchatbasic');
  $FluentChatBasic['translate']['Email'] = __('Email', 'fluentchatbasic');
  $FluentChatBasic['translate']['Location'] = __('Location', 'fluentchatbasic');
  $FluentChatBasic['translate']['Browser'] = __('Browser', 'fluentchatbasic');
  $FluentChatBasic['translate']['Last URL'] = __('Last URL', 'fluentchatbasic');
  $FluentChatBasic['translate']['Add Note'] = __('Add Note', 'fluentchatbasic');
  $FluentChatBasic['translate']['Save Changes'] = __('Save Changes', 'fluentchatbasic');
  $FluentChatBasic['translate']['new customer note...'] = __('new customer note...', 'fluentchatbasic');
  $FluentChatBasic['translate']['Active Chats'] = __('Active Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['total chat(s)'] = __('total chat(s)', 'fluentchatbasic');
  $FluentChatBasic['translate']['Unassigned Chats'] = __('Unassigned Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['No Unassigned Chats'] = __('No Unassigned Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['Your Active Chats'] = __('Your Active Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['No Active Chats'] = __('No Active Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['Sending'] = __('Sending', 'fluentchatbasic');
  $FluentChatBasic['translate']['sent'] = __('sent', 'fluentchatbasic');
  $FluentChatBasic['translate']['Submit'] = __('Submit', 'fluentchatbasic');
  $FluentChatBasic['translate']['operator(s) online'] = __('operator(s) online', 'fluentchatbasic');
  $FluentChatBasic['translate']['Upload File'] = __('Upload File', 'fluentchatbasic');
  $FluentChatBasic['translate']['Share Screenshot'] = __('Share Screenshot', 'fluentchatbasic');
  $FluentChatBasic['translate']['End Chat'] = __('End Chat', 'fluentchatbasic');
  $FluentChatBasic['translate']['Canned Response'] = __('Canned Response', 'fluentchatbasic');
  $FluentChatBasic['translate']['Chats'] = __('Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['New Conversation'] = __('New Conversation', 'fluentchatbasic');
  $FluentChatBasic['translate']['no feedback'] = __('no feedback', 'fluentchatbasic');
  $FluentChatBasic['translate']['Select A Chat'] = __('Select A Chat', 'fluentchatbasic');
  $FluentChatBasic['translate']['You can add canned responses under Operator Profile'] = __('You can add canned responses under Operator Profile', 'fluentchatbasic');
  $FluentChatBasic['translate']['Your Message ...'] = __('Your Message ...', 'fluentchatbasic');
  $FluentChatBasic['translate']['Press Enter to send. Press Shift + Enter for new line.'] = __('Press Enter to send. Press Shift + Enter for new line.', 'fluentchatbasic');
  $FluentChatBasic['translate']['Profile Image'] = __('Profile Image', 'fluentchatbasic');
  $FluentChatBasic['translate']['Full Name'] = __('Full Name', 'fluentchatbasic');
  $FluentChatBasic['translate']['Display Name'] = __('Display Name', 'fluentchatbasic');
  $FluentChatBasic['translate']['Job Title'] = __('Job Title', 'fluentchatbasic');
  $FluentChatBasic['translate']['Description'] = __('Description', 'fluentchatbasic');
  $FluentChatBasic['translate']['Show Online'] = __('Show Online', 'fluentchatbasic');
  $FluentChatBasic['translate']['local time in'] = __('local time in', 'fluentchatbasic');
  $FluentChatBasic['translate']['Canned Responses'] = __('Canned Responses', 'fluentchatbasic');
  $FluentChatBasic['translate']['Saving'] = __('Saving', 'fluentchatbasic');
  $FluentChatBasic['translate']['cURL Enabled'] = __('cURL Enabled', 'fluentchatbasic');
  $FluentChatBasic['translate']['cURL Not Enabled'] = __('cURL Not Enabled', 'fluentchatbasic');
  $FluentChatBasic['translate']['file uploads directory writable'] = __('file uploads directory writable', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['file uploads directory not writable'] = __('file uploads directory not writable', 'fluentchatbasic');
  $FluentChatBasic['translate']['Polling Interval (in seconds)'] = __('Polling Interval (in seconds)', 'fluentchatbasic');
  $FluentChatBasic['translate']['We recommend a value between 2 and 10. A lower value would ensure a more fluid chat flow, but will be harder on your servers. We recommend 3 for an ideal balance.'] = __('We recommend a value between 2 and 10. A lower value would ensure a more fluid chat flow, but will be harder on your servers. We recommend 3 for an ideal balance.', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Disable Widget When Operators are Offline'] = __('Disable Widget When Operators are Offline', 'fluentchatbasic');
  $FluentChatBasic['translate']['Allow File Uploads'] = __('Allow File Uploads', 'fluentchatbasic');
  $FluentChatBasic['translate']['Max Upload Size (in MB)'] = __('Max Upload Size (in MB)', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Deleting Files'] = __('Deleting Files', 'fluentchatbasic');
  $FluentChatBasic['translate']['Delete Uploaded Files'] = __('Delete Uploaded Files', 'fluentchatbasic');
  $FluentChatBasic['translate']['file(s)'] = __('file(s)', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Enable Share Screenshot Feature'] = __('Enable Share Screenshot Feature', 'fluentchatbasic');
  $FluentChatBasic['translate']["Your users can click the 'Share Screenshot' button and we will share a screenshot of their current browser page as an image attachment."] = __("Your users can click the 'Share Screenshot' button and we will share a screenshot of their current browser page as an image attachment.", 'fluentchatbasic');
  $FluentChatBasic['translate']['Fetch and Store Visitor Location'] = __('Fetch and Store Visitor Location', 'fluentchatbasic'); 
  $FluentChatBasic['translate']["This requires a cURL call to a third-party website. This feature will not work on a server which doesn't have access to internet."] = __("This requires a cURL call to a third-party website. This feature will not work on a server which doesn't have access to internet.", 'fluentchatbasic');
  $FluentChatBasic['translate']['Font Size'] = __('Font Size', 'fluentchatbasic');
  $FluentChatBasic['translate']['Widget Height'] = __('Widget Height', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Widget Width'] = __('Widget Width', 'fluentchatbasic');
  $FluentChatBasic['translate']['Chat Theme Color'] = __('Chat Theme Color', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Notification Sound'] = __('Notification Sound', 'fluentchatbasic');
  $FluentChatBasic['translate']['Background Type'] = __('Background Type', 'fluentchatbasic');
  $FluentChatBasic['translate']['Color'] = __('Color', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Image'] = __('Image', 'fluentchatbasic');
  $FluentChatBasic['translate']['Background Color'] = __('Background Color', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Background Image URL'] = __('Background Image URL', 'fluentchatbasic');
  $FluentChatBasic['translate']['Header Message'] = __('Header Message', 'fluentchatbasic');
  $FluentChatBasic['translate']['Background'] = __('Background', 'fluentchatbasic');
  $FluentChatBasic['translate']['Chat Icon'] = __('Chat Icon', 'fluentchatbasic');
  $FluentChatBasic['translate']['Default'] = __('Default', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Image'] = __('Image', 'fluentchatbasic');
  $FluentChatBasic['translate']['Chat Icon Image URL'] = __('Chat Icon Image URL', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Enable Animations'] = __('Enable Animations', 'fluentchatbasic');
  $FluentChatBasic['translate']['Custom CSS'] = __('Custom CSS', 'fluentchatbasic');
  $FluentChatBasic['translate']['Font Smoothing'] = __('Font Smoothing', 'fluentchatbasic');
  $FluentChatBasic['translate']['Add New Number'] = __('Add New Number', 'fluentchatbasic');
  $FluentChatBasic['translate']["Hover over an Extra, and you can preview it's look here."] = __("Hover over an Extra, and you can preview it's look here.", 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Send SMS On New Chat Conversations'] = __('Send SMS On New Chat Conversations', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Mobile Number'] = __('Mobile Number', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Carrier'] = __('Carrier', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Auto Initiate Chat If an Operator Is Online'] = __('Auto Initiate Chat If an Operator Is Online', 'fluentchatbasic');
  $FluentChatBasic['translate']['Auto Initiate Message'] = __('Auto Initiate Message', 'fluentchatbasic');
  $FluentChatBasic['translate']['Ask New Users for Name and Email Before Initiating Chat'] = __('Ask New Users for Name and Email Before Initiating Chat', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Cloud Animation'] = __('Cloud Animation', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Background Image'] = __('Background Image', 'fluentchatbasic');
  $FluentChatBasic['translate']['Start Chat'] = __('Start Chat', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Label - Name'] = __('Label - Name', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Label - Email'] = __('Label - Email', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Label - Message'] = __('Label - Message', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Start Chat - Footer Message'] = __('Start Chat - Footer Message', 'fluentchatbasic');
  $FluentChatBasic['translate']['Show Contact Form to New Users When Operators are Offline'] = __('Show Contact Form to New Users When Operators are Offline', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Contact Form'] = __('Contact Form', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Send Message'] = __('Send Message', 'fluentchatbasic');
  $FluentChatBasic['translate']['Email Recipients'] = __('Email Recipients', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Email Subject'] = __('Email Subject', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Email Body'] = __('Email Body', 'fluentchatbasic');
  $FluentChatBasic['translate']['Allow Users to Receive Chat Logs'] = __('Allow Users to Receive Chat Logs', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Label - Get Transcript'] = __('Label - Get Transcript', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Chat Logs - Email Subject'] = __('Chat Logs - Email Subject', 'fluentchatbasic');
  $FluentChatBasic['translate']['Ask Users for Chat Feedback'] = __('Ask Users for Chat Feedback', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Feedback Sent Message'] = __('Feedback Sent Message', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Chat End Message'] = __('Chat End Message', 'fluentchatbasic');
  $FluentChatBasic['translate']['Here you can enable / disable users from acting as chat operators or chat admins.'] = __('Here you can enable / disable users from acting as chat operators or chat admins.', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['WordPress admins are chat operators and chat admins by default, and their roles cannot be changed.'] = __('WordPress admins are chat operators and chat admins by default, and their roles cannot be changed.', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Chat Admin'] = __('Chat Admin', 'fluentchatbasic');
  $FluentChatBasic['translate']['Chat Operator'] = __('Chat Operator', 'fluentchatbasic');
  $FluentChatBasic['translate']['Access'] = __('Access', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['all'] = __('all', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['own'] = __('own', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['chat archives'] = __('chat archives', 'fluentchatbasic');
  $FluentChatBasic['translate']['Access and edit'] = __('Access and edit', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Edit'] = __('Edit', 'fluentchatbasic');  
  $FluentChatBasic['translate']['user roles, except their own'] = __('user roles, except their own', 'fluentchatbasic');  
  $FluentChatBasic['translate']['settings'] = __('settings', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['customer info'] = __('customer info', 'fluentchatbasic');
  $FluentChatBasic['translate']['unanswered chats, and answer them'] = __('unanswered chats, and answer them', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['active chats, and answer them'] = __('active chats, and answer them', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['operator profile'] = __('operator profile', 'fluentchatbasic');
  $FluentChatBasic['translate']['Access and edit customer info from'] = __('Access and edit customer info from', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['chats'] = __('chats', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['ID'] = __('ID', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['User Login'] = __('User Login', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['General'] = __('General', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Styling'] = __('Styling', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Extras'] = __('Extras', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Operators'] = __('Operators', 'fluentchatbasic'); 
  $FluentChatBasic['translate']['Active Chats'] = __('Active Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['Archived Chats'] = __('Archived Chats', 'fluentchatbasic');
  $FluentChatBasic['translate']['Operator Profile'] = __('Operator Profile', 'fluentchatbasic');
  $FluentChatBasic['translate']['Settings'] = __('Settings', 'fluentchatbasic');
  $FluentChatBasic['translate']['How was your experience?'] = __('How was your experience?', 'fluentchatbasic');
  $FluentChatBasic['translate']['Save Changes'] = __('Save Changes', 'fluentchatbasic');
  $FluentChatBasic['translate']['Sunday'] = __('Sunday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Monday'] = __('Monday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Tuesday'] = __('Tuesday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Wednesday'] = __('Wednesday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Thursday'] = __('Thursday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Friday'] = __('Friday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Saturday'] = __('Saturday', 'fluentchatbasic');
  $FluentChatBasic['translate']['Test'] = __('Test', 'fluentchatbasic');
  $FluentChatBasic['translate']['Delete'] = __('Delete', 'fluentchatbasic');
  $FluentChatBasic['translate']['Show Chat Widget On'] = __('Show Chat Widget On', 'fluentchatbasic');
  $FluentChatBasic['translate']['Home Page'] = __('Home Page', 'fluentchatbasic');
  $FluentChatBasic['translate']['All Pages'] = __('All Pages', 'fluentchatbasic');
  $FluentChatBasic['translate']['Posts'] = __('Posts', 'fluentchatbasic');
  $FluentChatBasic['translate']['Everywhere'] = __('Everywhere', 'fluentchatbasic');
  $FluentChatBasic['translate']['Upgrade to Pro for'] = __('Upgrade to Pro for', 'fluentchatbasic');
  $FluentChatBasic['translate']['operators can set their online hours'] = __('operators can set their online hours', 'fluentchatbasic');
  $FluentChatBasic['translate']['ask customer name & email'] = __('ask customer name & email', 'fluentchatbasic');
  $FluentChatBasic['translate']['view and edit customer info'] = __('view and edit customer info', 'fluentchatbasic');
  $FluentChatBasic['translate']['view customer location'] = __('view customer location', 'fluentchatbasic');
  $FluentChatBasic['translate']['view customer URL'] = __('view customer URL', 'fluentchatbasic');
  $FluentChatBasic['translate']['add customer notes'] = __('add customer notes', 'fluentchatbasic');
  $FluentChatBasic['translate']['ratings & feedback'] = __('ratings & feedback', 'fluentchatbasic');
  $FluentChatBasic['translate']['share files and screenshots'] = __('share files and screenshots', 'fluentchatbasic');
  $FluentChatBasic['translate']['get free sms notifications'] = __('get free sms notifications', 'fluentchatbasic');
  $FluentChatBasic['translate']['user role management'] = __('user role management', 'fluentchatbasic');
  $FluentChatBasic['translate']['and also'] = __('and also', 'fluentchatbasic');
  $FluentChatBasic['translate']['auto initiate chat with visitors'] = __('auto initiate chat with visitors', 'fluentchatbasic');
  $FluentChatBasic['translate']['see visitor location and URL'] = __('see visitor location and URL', 'fluentchatbasic');
  $FluentChatBasic['translate']['set custom chat logo'] = __('set custom chat logo', 'fluentchatbasic');
  $FluentChatBasic['translate']['free 6 month customer support'] = __('free 6 month customer support', 'fluentchatbasic');
  $FluentChatBasic['translate']['no monthly fees'] = __('no monthly fees', 'fluentchatbasic');
  $FluentChatBasic['translate']['Do you like FluentChat so far?'] = __('Do you like FluentChat so far?', 'fluentchatbasic');
  $FluentChatBasic['translate']['It would mean a lot if you would rate us.'] = __('It would mean a lot if you would rate us.', 'fluentchatbasic');
  $FluentChatBasic['translate']["We won't pester again."] = __("We won't pester again.", 'fluentchatbasic');
  $FluentChatBasic['translate']['opens in a new page'] = __('opens in a new page', 'fluentchatbasic');
}
add_action('plugins_loaded', 'FluentChatBasic_OnInit');

/* Create Database Tables */
register_activation_hook( __FILE__, 'FluentChatBasic_ActivatePlugin' );
function FluentChatBasic_ActivatePlugin() {
  global $FluentChatBasic, $wpdb;
  require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
  $charset_collate = $wpdb->get_charset_collate();

  /* Table structure for table `wp_fluentchat_chats` */
  $sql = "CREATE TABLE IF NOT EXISTS `".$FluentChatBasic['chatsTable']."` (
         `chat_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
         `customer_id` varchar(50) NOT NULL,
         `customer_unread` int(10) NOT NULL DEFAULT '0',
         `operator_unread` int(10) NOT NULL DEFAULT '0',
         `archived` binary(1) NOT NULL DEFAULT '0',
         `archive_text` longtext,
         `operators` text,
         `start` int(10) NOT NULL,
         `last` int(10) NOT NULL,
         `end` int(10) DEFAULT NULL,
         PRIMARY KEY (`chat_id`)
         ) ENGINE=InnoDB  DEFAULT CHARSET=utf8;";
  dbDelta( $sql );

  /* Table structure for table `wp_fluentchat_customers` */
  $sql = "CREATE TABLE IF NOT EXISTS `".$FluentChatBasic['customersTable']."` (
         `customer_id` varchar(50) NOT NULL,
         `name` varchar(255) DEFAULT NULL,
         `email` varchar(100) DEFAULT NULL,
         `browser` varchar(200) DEFAULT NULL,
         `ip` varchar(50) DEFAULT NULL,
         `location` varchar(100) DEFAULT NULL,
         `last_url` varchar(255) NOT NULL,
         `last_url_timestamp` int(10) unsigned NOT NULL,
         `notes` longtext,
         `meta` text,
         `last` int(10) DEFAULT NULL,
         PRIMARY KEY (`customer_id`)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  dbDelta( $sql );

  /* Table structure for table `wp_fluentchat_feedback` */
  $sql = "CREATE TABLE IF NOT EXISTS `".$FluentChatBasic['feedbackTable']."` (
         `feedback_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
         `customer_id` varchar(50) NOT NULL,
         `operator_id` int(10) unsigned NOT NULL,
         `chat_id` int(10) unsigned NOT NULL,
         `rating` int(2) NOT NULL,
         `comment` text NOT NULL,
         `timestamp` int(10) NOT NULL,
         PRIMARY KEY (`feedback_id`),
         KEY `operator_id` (`operator_id`)
         ) ENGINE=InnoDB  DEFAULT CHARSET=utf8;";
  dbDelta( $sql );

  /* Table structure for table `wp_fluentchat_messages` */
  $sql = "CREATE TABLE IF NOT EXISTS `".$FluentChatBasic['messagesTable']."` (
         `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
         `chat_id` int(10) unsigned NOT NULL,
         `operator` tinyint(1) NOT NULL DEFAULT '0',
         `customer_id` varchar(50) NOT NULL,
         `timestamp` int(10) NOT NULL,
         `message` text NOT NULL,
         PRIMARY KEY (`message_id`)
         ) ENGINE=InnoDB  DEFAULT CHARSET=utf8;";
  dbDelta( $sql );

  /* Table structure for table `wp_fluentchat_operators` */
  $sql = "CREATE TABLE IF NOT EXISTS `".$FluentChatBasic['operatorsTable']."` (
         `operator_id` int(9) unsigned NOT NULL,
         `admin` tinyint(1) NOT NULL,
         `operator` tinyint(1) NOT NULL,
         `email` varchar(50) NOT NULL,
         `nickname` varchar(50) DEFAULT NULL,
         `fullname` varchar(100) DEFAULT NULL,
         `job_title` varchar(255) DEFAULT NULL,
         `description` text,
         `image` varchar(255) DEFAULT NULL,
         `canned` longtext,
         `sunday` tinyint(1) NOT NULL DEFAULT '0',
         `sundayfrom` int(5) NOT NULL DEFAULT '900',
         `sundayto` int(5) NOT NULL DEFAULT '1700',
         `monday` tinyint(1) NOT NULL DEFAULT '1',
         `mondayfrom` int(5) NOT NULL DEFAULT '900',
         `mondayto` int(5) NOT NULL DEFAULT '1700',
         `tuesday` tinyint(1) NOT NULL DEFAULT '1',
         `tuesdayfrom` int(5) NOT NULL DEFAULT '900',
         `tuesdayto` int(5) NOT NULL DEFAULT '1700',
         `wednesday` tinyint(1) NOT NULL DEFAULT '1',
         `wednesdayfrom` int(5) NOT NULL DEFAULT '900',
         `wednesdayto` int(5) NOT NULL DEFAULT '1700',
         `thursday` tinyint(1) NOT NULL DEFAULT '1',
         `thursdayfrom` int(5) NOT NULL DEFAULT '900',
         `thursdayto` int(5) NOT NULL DEFAULT '1700',
         `friday` tinyint(1) NOT NULL DEFAULT '1',
         `fridayfrom` int(5) NOT NULL DEFAULT '900',
         `fridayto` int(5) NOT NULL DEFAULT '1700',
         `saturday` tinyint(1) NOT NULL DEFAULT '0',
         `saturdayfrom` int(5) NOT NULL DEFAULT '900',
         `saturdayto` int(5) NOT NULL DEFAULT '1700',
         PRIMARY KEY (`operator_id`)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
  dbDelta( $sql ); 

  $currentOperator = new ChatOperatorBasic();
  $currentOperator->updateOperator(get_current_user_id(), 1, 1);

  // delete_site_option($FluentChatBasic['nameLower'].'Pestered');
  update_site_option($FluentChatBasic['nameLower'].'ActivatedTime', strtotime('now'));

  if (!get_site_option($FluentChatBasic['nameLower'].'Settings')) {
    update_site_option($FluentChatBasic['nameLower'].'Settings', $FluentChatBasic['defaultSettings']);
  }
  if (!get_site_option($FluentChatBasic['nameLower'].'Styling')) {
    update_site_option($FluentChatBasic['nameLower'].'Styling', $FluentChatBasic['defaultStyling']);
  }

}

function FluentChatBasic_OnLogin() {  
  global $FluentChatBasic;
  if (current_user_can('edit_posts')) {
    $currentOperator = new ChatOperatorBasic();
    $currentOperator->updateOperator(get_current_user_id(), 1, 1);
  }
}
add_action('wp_login', 'FluentChatBasic_OnLogin');
function FluentChatBasic_OnLogout() {  
  global $FluentChatBasic;
  if (current_user_can('edit_posts')) {
    $onlineUsers = get_site_option($FluentChatBasic['nameLower'].'Online');
    unset($onlineUsers[get_current_user_id()]);
    if (count($onlineUsers) == 0) {
      delete_site_option($FluentChatBasic['nameLower'].'Online', $onlineUsers);
    } else {
      update_site_option($FluentChatBasic['nameLower'].'Online', $onlineUsers);  
    }
  }
}
add_action('wp_logout', 'FluentChatBasic_OnLogout');

/* Make Sure User Has Cookie */
add_action('template_redirect', 'FluentChatBasic_SetCookie', 1);
function FluentChatBasic_SetCookie() {
  global $FluentChatBasic;
  $currentCustomer = new ChatCustomerBasic();
}

class ChatOperatorBasic {

  public function __construct() {
    $this->ID = get_current_user_id();
  }

  public static function getSetting($setting) {
    global $FluentChatBasic;
    $settings = get_site_option($FluentChatBasic['nameLower'].'Settings');
    if (isset($settings[$setting])) {
      return $settings[$setting];
    }
    return $FluentChatBasic['defaultSettings'][$setting];
  }

  public static function isAdmin($ID) {
    global $wpdb, $FluentChatBasic;
    $ID = intval($ID);
    $admin = $wpdb->get_var( "SELECT admin FROM ".$FluentChatBasic['operatorsTable']." WHERE operator_id = '$ID'");
    return $admin == 1 ? true : false;
  }

  public static function isOperator($ID) {
    global $wpdb, $FluentChatBasic;
    $ID = intval($ID);
    $operator = $wpdb->get_var( "SELECT operator FROM ".$FluentChatBasic['operatorsTable']." WHERE operator_id = '$ID'");
    return $operator == 1 ? true : false;
  }

  public function getOperators() {
    global $wpdb, $FluentChatBasic;
    return $wpdb->get_results( "SELECT operator_id, email, nickname FROM ".$FluentChatBasic['operatorsTable'], ARRAY_A);
  }

  public function archiveChat($chatID) {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $chatID = esc_sql($chatID);
    $customerID = $wpdb->get_var( "SELECT customer_id FROM $chatsTable WHERE chat_id = '$chatID'" );
    do_action( $FluentChatBasic['nameLower'].'_chat_archive', $chatID, $customerID, $this->ID, 'operator');
    $result = $wpdb->update($chatsTable, array('archived' => true, 'end' => strtotime('now')), array('operators' => $this->ID, 'chat_id' => $chatID));
    $result = $wpdb->update($chatsTable, array('archived' => true, 'end' => strtotime('now')), array('operators' => null, 'chat_id' => $chatID));
  }  

  public function updateOperator($ID, $admin, $operator) {
    global $wpdb, $FluentChatBasic;
    $ID = intval($ID);    
    $operator = intval($operator);
    $admin = intval($admin);
    $userExists = $wpdb->get_var( "SELECT COUNT(*) FROM ".$FluentChatBasic['operatorsTable']." WHERE operator_id = '$ID'");
    if ( $userExists ) {
      $saveObject = array('admin' => $admin, 'operator' => $operator);
      $insert = $wpdb->update($FluentChatBasic['operatorsTable'], $saveObject, array('operator_id' => $ID));
    } else {
      $userData = get_userdata($ID);
      $saveObject = array();
      $saveObject['operator_id'] = $userData->ID;
      $saveObject['nickname'] = $userData->display_name;
      $saveObject['email'] = $userData->user_email;
      $saveObject['fullname'] = get_user_meta( $userData->ID, 'first_name', true ).' '.get_user_meta( $userData->ID, 'last_name', true );
      $saveObject['admin'] = $admin;
      $saveObject['operator'] = $operator;
      $saveObject['canned'] = array("If you need anything else, do let me know. If you are satisfied with our service, please consider leaving us a review.", "I will get back to you before the end of week. Please drop your email. Thanks.");
      $saveObject['canned'] = json_encode($saveObject['canned']);
      $insert = $wpdb->insert($FluentChatBasic['operatorsTable'], $saveObject);
    }
    return true;
  }

  public function getChatRating($chatID) {
    global $wpdb, $FluentChatBasic;
    $chatID = intval($chatID);
    $rating = $wpdb->get_row( "SELECT * FROM ".$FluentChatBasic['feedbackTable']." WHERE chat_id = '$chatID'", ARRAY_A);
    if ( $rating == null ) {
      return false;
    }
    $rating['comment'] = stripcslashes($rating['comment']);
    return $rating;    
  }

  public function getProfile($type = '*') {
    global $wpdb, $FluentChatBasic;
    if ( $type !== 'canned' && $type !== 'image' && $type !== 'nickname' ) {
      $type = '*';
    }
    $profile = $wpdb->get_row( "SELECT $type FROM ".$FluentChatBasic['operatorsTable']." WHERE
    operator_id = '$this->ID'
    ", ARRAY_A);
    if ( !empty($profile['canned']) && $profile['canned'] != null) {
      $profile['canned'] = json_decode(stripcslashes($profile['canned']), 1);
    }
    if ($type == '*') {
      return $profile; 
    }
    return $profile[$type];
  }

  public function markChatRead($chatID) {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $OperatorUnread = intval($wpdb->get_var( "SELECT operator_unread FROM $chatsTable WHERE chat_id = '$chatID'"));
    if ($chatID !== 0 && ctype_digit($chatID) && $OperatorUnread !== 0) {
      $wpdb->query("UPDATE ".$FluentChatBasic['chatsTable']." SET operator_unread=0, last= '".strtotime('now')."' WHERE chat_id='".$chatID."'");
    }
    return true;
  }

  public function getUnassignedChatsUnread() {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $sum = $wpdb->get_var( "SELECT SUM(operator_unread) FROM $chatsTable WHERE archived = 0 AND operators IS NULL");
    return intval($sum);
  }

  // Get All Unassigned Chats
  public function getUnassignedChats($lastUpdate = 0, $messages = 0) {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $count = $wpdb->get_results( "SELECT COUNT(*) FROM $chatsTable WHERE archived = 0 AND operators IS NULL", ARRAY_A);
    $response = $wpdb->get_results( "SELECT chat_id, operator_unread, customer_id, operators, start FROM $chatsTable WHERE archived = 0 AND operators IS NULL", ARRAY_A);
    foreach ($response as $key => $value) {
      if ($messages) {
        $response[$key]['messages'] = $this->getChatMessages($value['chat_id'], $lastUpdate);
        if ($response[$key]['messages']==false) {
          unset($response[$key]['messages']);
        }
      }
    }
    return array('count' => $count, 'data' => $response);
  }

  public function getOperatorChatsUnread() {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $sum = $wpdb->get_var( "SELECT SUM(operator_unread) FROM $chatsTable WHERE archived = 0 AND operators = $this->ID");
    return intval($sum);
  }  

  // Get All Active Chats Assigned to Operator
  public function getOperatorChats($operator_id = 'self', $lastUpdate = 0, $messages = 0, $archived = 0, $limit = 20, $offset = 0, $meta = false) {
    global $wpdb, $FluentChatBasic;
    $operator_id = $operator_id === 'self' ? $this->ID : $operator_id;
    $operator_id = $operator_id === 'NULL' ? NULL : $operator_id;
    $operator_id = ctype_digit($operator_id) ? intval($operator_id) : $operator_id;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $messagesTable = $FluentChatBasic['messagesTable'];
    $limit = intval($limit);
    $offset = intval($offset);
    $response = array();
    if ($meta) {
      if (!empty($meta['search'])) {
        $search = esc_sql($meta['search']);
        $tempResponse = $wpdb->get_col( "SELECT DISTINCT chat_id FROM $messagesTable WHERE message LIKE '%$search%'");
        if ($tempResponse !== null) {
          $count = 0;
          foreach ($tempResponse as $key => $value) {
            $operator = $wpdb->get_var( "SELECT operators FROM $chatsTable WHERE chat_id = $value");
            $operator = ctype_digit($operator) ? intval($operator) : $operator;
            if ( $operator_id === 0 || $operator === $operator_id ) {
              $count++;
              if (count($response) < $limit + $offset) {
                $response[] = $wpdb->get_row( "SELECT chat_id, operator_unread, customer_id, operators, start, end FROM $chatsTable WHERE chat_id = $value", ARRAY_A);
              }
            }
          }
        }
        $response = array_slice($response,-$limit,$limit,true);
      }
    } else {
      if ($operator_id === 0) {
        $operatorQuery = '';
      } else if ($operator_id === NULL) {
        $operatorQuery = "AND operators IS NULL";
      } else {
        $operatorQuery = "AND operators = $operator_id";
      }
      $count = $wpdb->get_var( "SELECT COUNT(*) FROM $chatsTable WHERE archived = $archived $operatorQuery");
      $response = $wpdb->get_results( "SELECT chat_id, operator_unread, customer_id, operators, start, end FROM $chatsTable WHERE archived = $archived $operatorQuery ORDER BY chat_id DESC LIMIT $limit OFFSET $offset", ARRAY_A);
    }
    foreach ($response as $key => $value) {
      if ($messages) {
        $response[$key]['messages'] = $this->getChatMessages($value['chat_id'], $lastUpdate);
        if ($response[$key]['messages']==false) {
          unset($response[$key]['messages']);
        }        
      }
    }
    return array('count' => intval($count), 'data' => array_values($response));
  }

  // Get Customer Info based on Customer ID
  public function getCustomerInfo($customerID, $lastUpdate = 0) {
    global $wpdb, $FluentChatBasic;
    $customerInfo = $wpdb->get_row( "SELECT * FROM ".$FluentChatBasic['customersTable']." WHERE
    customer_id = '$customerID' AND
    last >= $lastUpdate
    ", ARRAY_A);
    if ( !empty($customerInfo['notes']) ) {
      $customerInfo['notes'] = json_decode($customerInfo['notes'], 1);
    }
    $customerInfo['gravatar'] = "https://www.gravatar.com/avatar/".md5(strtolower(trim($customerInfo['email'])))."?s=200";
    foreach ($customerInfo as $key => $value) {
      if ($value === NULL) {
        unset($customerInfo[$key]);
      }
    }
    return $customerInfo;
  }

  // Get Operator Info based on Operator ID
  public function getOperatorInfo($operatorID) {
    global $wpdb, $FluentChatBasic;
    $operatorInfo = $wpdb->get_row( "SELECT * FROM ".$FluentChatBasic['operatorsTable']." WHERE
    operator_id = '$operatorID'", ARRAY_A);
    foreach ($operatorInfo as $key => $value) {
      if ($key === 'image' && $value === NULL) {
        $operatorInfo['image'] = plugins_url('/', __FILE__).'assets/operator_male.png';
      }
      if ($value === NULL) {
        unset($operatorInfo[$key]);
      }
    }
    return $operatorInfo;
  }

  // Record New Message
  public function recordMessage($chatID, $message) {
    global $wpdb, $FluentChatBasic;
    $chatID = intval(esc_sql($chatID));
    $chatsTable = $FluentChatBasic['chatsTable'];
    $customerID = $wpdb->get_var( "SELECT customer_id FROM $chatsTable WHERE chat_id = '$chatID'" );
    $hasOperator = $wpdb->get_var( "SELECT operators FROM $chatsTable WHERE chat_id = '$chatID'" );    
    if ($hasOperator == NULL) {
      $wpdb->update($chatsTable, array( 'operators' => get_current_user_id(), 'last' => strtotime('now') ), array('chat_id'=>$chatID));
      $messagesSoFar = $this->getChatMessages($chatID);
      do_action( $FluentChatBasic['nameLower'].'_chat_assign', $chatID, $customerID, get_current_user_id(), $messagesSoFar);
    }
    $chatOperatorID = $wpdb->get_var("SELECT operators FROM ".$FluentChatBasic['chatsTable']." WHERE chat_id = '$chatID'");
    $tempValue = apply_filters( $FluentChatBasic['nameLower'].'_message_new', $message, $chatID, $customerID, $chatOperatorID, 'operator');
    if ($tempValue === false) {
      return $newChatID;
    }    
    if ($tempValue !== NULL && trim($tempValue) !== '') {
      $message = $tempValue;
    }    
    $wpdb->insert($FluentChatBasic['messagesTable'], array(
      'chat_id' => $chatID,
      'operator' => 1,
      'customer_id' => $customerID,
      'timestamp' => strtotime('now'),
      'message' => esc_sql($message)
    ));
    $wpdb->query("UPDATE ".$FluentChatBasic['chatsTable']." SET customer_unread=customer_unread+1, last= '".strtotime('now')."' WHERE chat_id='".$chatID."'");
  }

  // Fetch Messages For One Chat
  public function getChatMessageCount($chatID) {
    global $wpdb, $FluentChatBasic;
    $messagesTable = $FluentChatBasic['messagesTable'];
    $newMessages = $wpdb->get_var( "SELECT COUNT(*) FROM $messagesTable WHERE chat_id = '$chatID'");
    return $newMessages;
  }  

  // Fetch Messages For One Chat
  public function getChatMessages($chatID, $lastUpdate = 0) {
    global $wpdb, $FluentChatBasic;
    $messagesTable = $FluentChatBasic['messagesTable'];
    $lastUpdate = esc_sql($lastUpdate);
    $newMessages = $wpdb->get_results( "SELECT message_id, chat_id, operator, timestamp, message FROM $messagesTable WHERE
      timestamp >= $lastUpdate AND chat_id = '$chatID'"
      , ARRAY_A);
    if (count($newMessages)>0) {
      foreach ($newMessages as $key => $value) {
        $response[$value['message_id']] = array('timestamp'=>$value['timestamp'], 'message'=> stripcslashes($value['message']), 'operator' => intval($value['operator']));
      }
      return $response;
    } else {
      return false;
    }
  }
}

class ChatCustomerBasic {
  public $customerID;
  public function __construct() {
    global $wpdb, $FluentChatBasic;

    // Cookie Format: [CustomerID]-[NewVisitor]-[WasChatOpened]-[IsChatOpen]-[ChatScreen]
    if ( !isset($_COOKIE[$FluentChatBasic['cookieName']]) ) {
      $chatID = substr(md5(uniqid('')), 0, 8);
      $_COOKIE[$FluentChatBasic['cookieName']] = "$chatID-1-0-0-list";
      setcookie($FluentChatBasic['cookieName'], "$chatID-1-0-0-list", time()+(365 * 24 * 60 * 60 * 10), SITECOOKIEPATH);
    }

    $customerID = explode('-', $_COOKIE[$FluentChatBasic['cookieName']]);
    $this->customerID = esc_sql($customerID[0]);
    if ($wpdb->get_var( "SELECT COUNT(*) FROM ".$FluentChatBasic['customersTable']." WHERE customer_id = '$this->customerID'")==0) {
      $saveObject['customer_id'] = $this->customerID;
      $wpdb->insert($FluentChatBasic['customersTable'], $saveObject);
    }
    $this->activeChats = $wpdb->get_var( "SELECT COUNT(*) FROM ".$FluentChatBasic['chatsTable']." WHERE customer_id = '$this->customerID' AND archived = 0");
  }

  public function updateInfo($info = array()) {
    global $wpdb, $FluentChatBasic;
    $saveObject = array();
    if ( !empty($info['name']) ) {
      $saveObject['name'] = $info['name'];
    }
    if ( !empty($info['email']) ) {
      $saveObject['email'] = strtolower(esc_sql($info['email']));
    }
    if ( !empty($info['browser']) ) {
      $saveObject['browser'] = esc_sql($info['browser']);
    }
    if ( !empty($info['location']) ) {
      $saveObject['location'] = esc_sql($info['location']);
    }
    $wpdb->update($FluentChatBasic['customersTable'], $saveObject, array('customer_id' => $this->customerID));
  }

  public function getInfo($info = '') {
    global $wpdb, $FluentChatBasic;
    $saveObject = array();
    if ($info === '') {
      $query = '*';
      return $wpdb->get_row( "SELECT $query FROM ".$FluentChatBasic['customersTable']." WHERE customer_id = '$this->customerID'");
    } else if ($info === 'name' || $info === 'email') {
      $query = $info;
      $var = $wpdb->get_var( "SELECT $query FROM ".$FluentChatBasic['customersTable']." WHERE customer_id = '$this->customerID'");
      return empty($var) || $var === 'Unknown' ? '' : $var;
    } else {
      return '';
    }
  }  

  public function getOnlineOperators() {
    global $wpdb, $FluentChatBasic;
    $online = get_site_option($FluentChatBasic['nameLower'].'Online');
    if (is_array($online) && count($online) > 0) {
      return count($online);
    }
    return 0;
  }

  public function checkIfOperatorOnline($operator_id) {
    global $wpdb, $FluentChatBasic;
    $operator_id = intval($operator_id);
    $online = get_site_option($FluentChatBasic['nameLower'].'Online');
    if (is_array($online) && $online[$operator_id]=='online') {
      return true;
    }
    return false;
  }  

  public function archiveChat($chatID) {
    global $wpdb, $FluentChatBasic;
    $chatID = esc_sql($chatID);
    $operatorID = $wpdb->get_var("SELECT operators FROM ".$FluentChatBasic['chatsTable']." WHERE chat_id = '$chatID' AND customer_id = '$this->customerID'");
    do_action( $FluentChatBasic['nameLower'].'_chat_archive', $chatID, $this->customerID, $operatorID, 'customer');
    $wpdb->update($FluentChatBasic['chatsTable'], array('archived' => true, 'end' => strtotime('now')), array('customer_id' => $this->customerID, 'chat_id' => $chatID));
  }

  public function markChatRead($chatID) {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    if ($chatID !== 0 && ctype_digit($chatID)) {
      $wpdb->query("UPDATE ".$FluentChatBasic['chatsTable']." SET customer_unread=0, last= '".strtotime('now')."' WHERE chat_id='".$chatID."'");
      return true;
    }
    return false;
  }

  public function sendSMS($message) {
    global $wpdb, $FluentChatBasic;
    $headers = array();
    $message = is_array($message) ? implode("\r\n", $message) : $message;
    $from = "[$this->customerID]";
    $emailInfo = $this->getInfo('email');
    $sendSMSNumbers = ChatOperatorBasic::getSetting('sendSMSNumbers');
    $from = empty($emailInfo) ? $from : $emailInfo;
    $headers[] = "From: ".$from." <".get_option('admin_email').">";
    if ( !ChatOperatorBasic::getSetting('sendSMS') ) {
      return false;
    }
    if ( !empty($sendSMSNumbers) ) {
      foreach ($sendSMSNumbers as $key => $value) {
        if ( empty($value['number']) || empty($value['carrier']) ) {
          continue;
        }
        $email = str_replace('[number]', $value['number'], $value['carrier']);        
        $sendSMS = wp_mail( $email, '', $message, $headers );
      }
    }
  }

  public function recordMessage($chatID, $message, $operator = 0) {
    global $wpdb, $FluentChatBasic;
    if ( empty($chatID) || $chatID === 0 ) {
      $wpdb->insert($FluentChatBasic['chatsTable'], array(
        'customer_id' => $this->customerID,
        'start' => strtotime('now'),
        'last' => strtotime('now')
      ));
      $newChatID = $wpdb->insert_id;
    } else {
      $newChatID = $chatID;
    }
    $message = is_array($message) ? $message : array($message);
    foreach ($message as $key => $value) {
      $chatOperatorID = $wpdb->get_var( "SELECT operators FROM ".$FluentChatBasic['chatsTable']." WHERE chat_id = '$newChatID'");
      $tempValue = apply_filters( $FluentChatBasic['nameLower'].'_message_new', $value, $newChatID, $this->customerID, $chatOperatorID, 'customer');
      if ($tempValue === false) {
        return $newChatID;
      }
      if ($tempValue !== NULL && trim($tempValue) !== '') {
        $value = $tempValue;
      }
      $wpdb->insert($FluentChatBasic['messagesTable'], array(
        'chat_id' => $newChatID,
        'customer_id' => $this->customerID,
        'timestamp' => strtotime('now'),
        'operator' => $operator,
        'message' => esc_sql($value)
      ));
      $wpdb->query("UPDATE ".$FluentChatBasic['chatsTable']." SET operator_unread=operator_unread+1, last= '".strtotime('now')."' WHERE chat_id='".$newChatID."'");
    }
    return $newChatID;
  }

  public function getChats($lastUpdate = 0) {
    global $wpdb, $FluentChatBasic;
    $chatsTable = $FluentChatBasic['chatsTable'];
    $operatorsTable = $FluentChatBasic['operatorsTable'];
    $tempChats = $wpdb->get_results( "SELECT chat_id, customer_unread, operators, last FROM $chatsTable WHERE archived = 0 AND customer_id = '$this->customerID'", ARRAY_A);
    $response = array();
    foreach ($tempChats as $key => $value) {
      $response[$value['chat_id']] = $value;
      unset($response[$value['chat_id']]['chat_id']);
      $response[$value['chat_id']]['messages'] = $this->getChatMessages($value['chat_id'], $lastUpdate);
      if ($value['operators'] != NULL) {
        $response[$value['chat_id']]['online'] = $this->checkIfOperatorOnline($value['operators']);
      }
      if ($value['operators'] != NULL && $value['last'] > $lastUpdate) {
        $response[$value['chat_id']]['operators'] = $wpdb->get_row( "SELECT email, nickname, fullname, image FROM $operatorsTable WHERE
              operator_id = '".$value['operators']."'
              ", ARRAY_A);
      } else {
        unset($response[$value['chat_id']]['operators']);
      }
      if ($response[$value['chat_id']]['messages']==false) {
        unset($response[$value['chat_id']]['messages']);
      }
      if ($value['last'] < $lastUpdate && !isset($response[$value['chat_id']]['online']) && !isset($response[$value['chat_id']]['messages'])) {
        unset($response[$value['chat_id']]);
      }
    }
    return $response;
  }

  // Fetch Messages For One Chat
  public function getChatMessages($chatID, $lastUpdate) {
    global $wpdb, $FluentChatBasic;
    $messagesTable = $FluentChatBasic['messagesTable'];
    $lastUpdate = esc_sql($lastUpdate);
    $newMessages = $wpdb->get_results( "SELECT message_id, chat_id, operator, timestamp, message FROM $messagesTable WHERE
      timestamp >= $lastUpdate AND chat_id = '$chatID'"
      , ARRAY_A);
    if (count($newMessages)>0) {
      foreach ($newMessages as $key => $value) {
        $response[$value['message_id']] = array('timestamp'=>$value['timestamp'], 'message'=> stripcslashes($value['message']), 'operator' => intval($value['operator']));
      }
      return $response;
    } else {
      return false;
    }
  }

  public function getChatOperatorInfo($chatID) {
    global $wpdb, $FluentChatBasic;
    if ( !is_numeric($chatID) ) {
      return false;
    }
    $operator = $wpdb->get_var("SELECT operators FROM ".$FluentChatBasic['chatsTable']." WHERE chat_id = '$chatID' AND customer_id = '$this->customerID'");
    if ($operator == NULL) {
      return false;
    }
    return $wpdb->get_row( "SELECT email, nickname, fullname, image FROM ".$FluentChatBasic['operatorsTable']." WHERE operator_id = '$operator'", ARRAY_A);
  }
}



// Add Custom CSS to all Admin Pages
add_action('admin_head', 'FluentChatBasic_AdminCSS');
function FluentChatBasic_AdminCSS() {
  global $_wp_admin_css_colors, $FluentChatBasic;
    $admin_color = get_user_option( 'admin_color' );
    $colors      = $_wp_admin_css_colors[$admin_color]->colors;

  ?><style>
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard .wp-menu-name {
      position: relative;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard .wp-menu-name .update-plugins {
      position: absolute;
      top: 1px;
      left: 15px;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard .wp-menu-name .update-plugins span {
      padding: 0 5px;
      line-height: 14px;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard ul li span.update-plugins {
      margin-bottom: -1px;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard ul li span.update-plugins > span {
      padding: 0 5px;
      line-height: 15px;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard .wp-menu-image::before {
      content: '';
      position: absolute;
      width: 15px;
      height: 12px;
      padding: 0;
      top: 10px;
      left: 10px;
      background: rgba(255,255,255,.5);
      border-radius: 2px 2px 2px 0;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard .wp-menu-image::after {
      content: '';
      position: absolute;
      top: 22px;
      left: 10px;
      width: 0;
      height: 0;
      border-style: solid;
      border-width: 4px 4px 0 0;
      border-color: rgba(255,255,255,.5) transparent transparent transparent;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard:hover .wp-menu-image::before {
      background-color: <?php echo $colors[3]; ?>;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard:hover .wp-menu-image::after {
      border-color: <?php echo $colors[3]; ?> transparent transparent transparent;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard.wp-has-current-submenu .wp-menu-image::before {
      background-color: #fff;
    }
    #toplevel_page_<?php echo $FluentChatBasic['nameLower']; ?>-dashboard.wp-has-current-submenu .wp-menu-image::after {
      border-color: #fff transparent transparent transparent;
    }
    </style><?php
}


// Add Dashboard Menu Page
add_action('admin_menu', 'FluentChatBasic_AdminMenu' );
function FluentChatBasic_AdminMenu() {
  global $wpdb, $wp_version, $FluentChatBasic, $submenu;
  add_action( 'admin_enqueue_scripts', 'FluentChatBasic_AdminAssets' );
  $current_user = wp_get_current_user();

  if (ChatOperatorBasic::isOperator($current_user->ID)) {
    $currentOperator = new ChatOperatorBasic();
    $UnreadOne = $currentOperator->getUnassignedChatsUnread();
    $UnreadTwo = $currentOperator->getOperatorChatsUnread();
    $totalUnread = $UnreadOne + $UnreadTwo;
    $totalUnread = $totalUnread > 0 ? "&nbsp;<span class='update-plugins'><span>$totalUnread</span></span>" : '';
  } else {
    $totalUnread = '';
  }

  if (!ChatOperatorBasic::isOperator($current_user->ID) && ChatOperatorBasic::isAdmin($current_user->ID)) {
  add_menu_page('Archived Chats', $FluentChatBasic['nameCamelProper'].$totalUnread, 'edit_posts', $FluentChatBasic['nameLower'].'-dashboard', 'FluentChatBasicDashboardPage', '', '31.3501' );
  } else if (ChatOperatorBasic::isOperator($current_user->ID) || ChatOperatorBasic::isAdmin($current_user->ID)) {
  add_menu_page('Active Chats', $FluentChatBasic['nameCamelProper'].$totalUnread, 'edit_posts', $FluentChatBasic['nameLower'].'-dashboard', 'FluentChatBasicDashboardPage', '', '31.3501' );    
  }
  if (ChatOperatorBasic::isOperator($current_user->ID)) {
  add_submenu_page($FluentChatBasic['nameLower'].'-dashboard', 'Active Chats', $FluentChatBasic['translate']['Active Chats'].$totalUnread, 'edit_posts', $FluentChatBasic['nameLower'].'-dashboard', 'FluentChatBasicDashboardPage' );
  }
  if (!ChatOperatorBasic::isOperator($current_user->ID) && ChatOperatorBasic::isAdmin($current_user->ID)) {
  add_submenu_page($FluentChatBasic['nameLower'].'-dashboard', 'Archived Chats', $FluentChatBasic['translate']['Archived Chats'], 'edit_posts', $FluentChatBasic['nameLower'].'-dashboard', 'FluentChatBasicDashboardPage' );
  } else  if (ChatOperatorBasic::isOperator($current_user->ID) || ChatOperatorBasic::isAdmin($current_user->ID)) {
  add_submenu_page($FluentChatBasic['nameLower'].'-dashboard', 'Archived Chats', $FluentChatBasic['translate']['Archived Chats'], 'edit_posts', $FluentChatBasic['nameLower'].'-archives', 'FluentChatBasicDashboardPage' );
  }
  if (ChatOperatorBasic::isOperator($current_user->ID)) {
  add_submenu_page($FluentChatBasic['nameLower'].'-dashboard', 'Operator Profile', $FluentChatBasic['translate']['Operator Profile'], 'edit_posts', $FluentChatBasic['nameLower'].'-profile', 'FluentChatBasicDashboardPage' );
  }  
  if (ChatOperatorBasic::isAdmin($current_user->ID)) {
  add_submenu_page($FluentChatBasic['nameLower'].'-dashboard', 'Chat Settings', $FluentChatBasic['translate']['Settings'], 'edit_posts', $FluentChatBasic['nameLower'].'-settings', 'FluentChatBasicDashboardPage' );
  }
}

// Load Admin Assets
function FluentChatBasic_AdminAssets($hook) {
  global $wp_version, $FluentChatBasic;

  $onlineUsers = get_site_option($FluentChatBasic['nameLower'].'Online');
  if (!is_array($onlineUsers)) {
    $onlineUsers = array();
  }
  $onlineUsers[get_current_user_id()] = 'online';
  update_site_option($FluentChatBasic['nameLower'].'Online', $onlineUsers);

  if (strpos($hook, '_page_'.$FluentChatBasic['nameLower'].'-')===false) {
    return false;
  }
  if (!get_site_option($FluentChatBasic['nameLower'].'Settings')) {
    update_site_option($FluentChatBasic['nameLower'].'Settings', $FluentChatBasic['defaultSettings']);
  }
  if (!get_site_option($FluentChatBasic['nameLower'].'Styling')) {
    update_site_option($FluentChatBasic['nameLower'].'Styling', $FluentChatBasic['defaultStyling']);
  }  
  $current_user = wp_get_current_user();
  wp_enqueue_script('react', plugins_url( 'lib/react'.($FluentChatBasic['env'] == 'live' ? '.min' : '').'.js', __FILE__ ), array(), 1, true);
  wp_enqueue_script('react-dom', plugins_url( 'lib/react-dom'.($FluentChatBasic['env'] == 'live' ? '.min' : '').'.js', __FILE__ ), array(), 1, true);

  /* Load MomentJS*/
  wp_enqueue_script('moment', plugins_url( 'lib/moment/moment.min.js', __FILE__ ), array(), 1, true); 
  
  $locale = strtolower(str_replace('_','-',get_locale()));
  $localeLanguage = substr($locale, 0, strpos($locale, '-'));
  if (file_exists(plugin_dir_path( __FILE__ ) . 'lib/moment/locale/'.$locale.'.js')) {
    wp_enqueue_script('moment-'.$locale, plugins_url( 'lib/moment/locale/'.$locale.'.js', __FILE__ ), array(), 1, true); 
  } else if (file_exists(plugin_dir_path( __FILE__ ) . 'lib/moment/locale/'.$localeLanguage.'.js')) {
    wp_enqueue_script('moment-'.$localeLanguage, plugins_url( 'lib/moment/locale/'.$localeLanguage.'.js', __FILE__ ), array(), 1, true);
  }

  wp_enqueue_style($FluentChatBasic['nameLower'].'-admin', plugins_url( 'dist/chat-admin.css', __FILE__ ), array(), 1);

  if (strpos($hook, 'dashboard')!==false) {
    $chatOperator = new ChatOperatorBasic();
    wp_enqueue_script($FluentChatBasic['nameLower'].'-dashboard', plugins_url( 'dist/chat-dashboard.min.js', __FILE__ ), array('react', 'react-dom'), 1, true);
    wp_localize_script($FluentChatBasic['nameLower'].'-dashboard', $FluentChatBasic['nameCamel'].'Translate', $FluentChatBasic['translate']);
    wp_localize_script($FluentChatBasic['nameLower'].'-dashboard', $FluentChatBasic['nameCamel'].'Globals', array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'plugin_dir' => plugins_url('/', __FILE__),
      'operator' => $current_user->ID,
      'operatorCannedMessages' => $chatOperator->getprofile('canned'),
      'operatorImage' => $chatOperator->getprofile('image'),
      'operatorNickname' => $current_user->display_name
    ));
  }

  if (strpos($hook, 'settings')!==false) {
    $users = array();
    $userList = get_users(array('role__not_in' => array('subscriber'), 'number' => 999));
    add_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
    $dir = wp_upload_dir();
    remove_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
    foreach ($userList as $key => $value) {
      $users[$value->ID] = array(
        'admin' => user_can( $value->ID, 'administrator' ),
        'canAdmin' => ChatOperatorBasic::isAdmin($value->ID),
        'canOperator' => ChatOperatorBasic::isOperator($value->ID),
        'user_login' => $value->user_login
        );
    }
    $pages = array();
    $rawpages = get_pages();
    foreach ($rawpages as $key => $value) {
      $pages[$value->post_name] = $value->post_title;
    }
    $posts = array();
    $rawposts = get_post_types(array('public'   => true,'_builtin' => false), 'objects');
    foreach ($rawposts as $key => $value) {
      $posts[$value->name] = $value->label;
    }

    // delete_site_option($FluentChatBasic['nameLower'].'Pestered');
    $ActivatedTime = get_site_option($FluentChatBasic['nameLower'].'ActivatedTime');
    $NowTime = strtotime('now');
    $pester = false;
    if ( (($NowTime - $ActivatedTime)/(60 * 60 * 24)) > 7 ) {
      if (!get_site_option($FluentChatBasic['nameLower'].'Pestered')) {
        update_site_option($FluentChatBasic['nameLower'].'Pestered', true);
        $pester = true;
      }
    }

    wp_enqueue_style($FluentChatBasic['nameLower'].'-frontend', plugins_url( 'dist/chat-front.css', __FILE__ ), array(), 1);
    wp_enqueue_script($FluentChatBasic['nameLower'].'-settings', plugins_url( 'dist/chat-settings.min.js', __FILE__ ), array('react', 'react-dom'), 1, true);
    wp_localize_script($FluentChatBasic['nameLower'].'-settings', $FluentChatBasic['nameCamel'].'Translate', $FluentChatBasic['translate']);
    wp_localize_script($FluentChatBasic['nameLower'].'-settings', $FluentChatBasic['nameCamel'].'Globals', array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'plugin_dir' => plugins_url('/', __FILE__),
      'operator' => $current_user->ID,
      'operatorNickname' => $current_user->display_name,
      'operatorsList' => $users,
      'fileCount' => FluentChatBasic_FileCount(),
      'fileSize' => FluentChatBasic_FileSize(),
      'cURL' => function_exists('curl_version'),
      'writable' => is_writable($dir['path']),
      'carriers' => $FluentChatBasic['SMSCarriers'],
      'pages' => $pages,
      'pester' => $pester,
      'posts' => $posts,
      'styling' => get_site_option($FluentChatBasic['nameLower'].'Styling'),
      'settings' => get_site_option($FluentChatBasic['nameLower'].'Settings')
    ));
  }

  if (strpos($hook, 'profile')!==false) {
    wp_enqueue_style($FluentChatBasic['nameLower'].'-frontend', plugins_url( 'dist/chat-front.css', __FILE__ ), array(), 1);
    wp_enqueue_script($FluentChatBasic['nameLower'].'-profile', plugins_url( 'dist/chat-profile.min.js', __FILE__ ), array('react', 'react-dom'), 1, true);
    wp_localize_script($FluentChatBasic['nameLower'].'-profile', $FluentChatBasic['nameCamel'].'Translate', $FluentChatBasic['translate']);
    wp_localize_script($FluentChatBasic['nameLower'].'-profile', $FluentChatBasic['nameCamel'].'Globals', array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'plugin_dir' => plugins_url('/', __FILE__),
      'operator' => $current_user->ID,
      'timezone' => get_option('timezone_string'),
      'operatorNickname' => $current_user->display_name
    ));
  }

  if ( strpos($hook, 'archives')!==false ) {
    $currentOperator = new ChatOperatorBasic();
    wp_enqueue_script($FluentChatBasic['nameLower'].'-archives', plugins_url( 'dist/chat-archives.min.js', __FILE__ ), array('react', 'react-dom'), 1, true);
    wp_localize_script($FluentChatBasic['nameLower'].'-archives', $FluentChatBasic['nameCamel'].'Translate', $FluentChatBasic['translate']);
    wp_localize_script($FluentChatBasic['nameLower'].'-archives', $FluentChatBasic['nameCamel'].'Globals', array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'plugin_dir' => plugins_url('/', __FILE__),
      'operator' => $current_user->ID,
      'admin' => ChatOperatorBasic::isAdmin($current_user->ID),
      'operatorsList' => $currentOperator->getOperators(),
      'timezone' => get_option('timezone_string'),
      'dateformat' => get_option('date_format'),
      'timeformat' => get_option('time_format'),
      'operatorNickname' => $current_user->display_name
    ));
  }
}
function FluentChatBasicDashboardPage() {
  global $wp_version, $FluentChatBasic;  
  echo '<div id="FluentChatBasicContainer"><div class="FluentChatBasicCSS" id="'.$FluentChatBasic['nameCamel'].'Dashboard"></div></div>';
}

function FluentChatBasic_FileCount() {
  add_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
  $dir = wp_upload_dir();
  remove_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
  $files = scandir($dir['path']);
  $fileCount = 0;
  foreach ($files as $key => $value) {
    $fileCount = substr($value, 0, 1) !== '.' ? $fileCount + 1 : $fileCount;
  }
  return $fileCount;
}

function FluentChatBasic_FileSize() {
  add_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
  $dir = wp_upload_dir();
  remove_filter('upload_dir', 'FluentChatBasic_FixUploadDirPath');
  $files = scandir($dir['path']);
  $fileSize = 0;
  foreach ($files as $key => $value) {
    $fileSize = substr($value, 0, 1) !== '.' ? $fileSize + filesize($dir['path'].'/'.$value) : $fileSize;
  }
  return $fileSize / ( 1024 * 1024 );
}

// Load FrontEnd assert_options
add_action( 'wp_enqueue_scripts', 'FluentChatBasic_FrontEndAssets' );
function FluentChatBasic_FrontEndAssets() {
  global $wp_version, $FluentChatBasic;
  $showWidget = false;
  
  if ( ChatOperatorBasic::getSetting('showWidget') === false ) {
    $showWidget = false;
  } else if ( ChatOperatorBasic::getSetting('showWidgetEverywhere') ) {
    $showWidget = true;
  } else if ( is_home() && ChatOperatorBasic::getSetting('showWidgetHome') ) {
    $showWidget = true;
  } else {
    $post = get_post();
    if ($post !== NULL && $post->post_type === 'page') {
      $pagesToShow = ChatOperatorBasic::getSetting('showWidgetPages');
      if ( isset($pagesToShow[$post->post_name]) && $pagesToShow[$post->post_name] ) {
        $showWidget = true;
      }
    } else if ($post !== NULL && $post->post_type === 'post' && ChatOperatorBasic::getSetting('showWidgetPost')) {
      $showWidget = true;
    } else if ($post !== NULL) {
      $postsToShow = ChatOperatorBasic::getSetting('showWidgetPosts');
      if ( isset($postsToShow[$post->post_type]) && $postsToShow[$post->post_type] ) {
        $showWidget = true;
      }      
    }
  }
  $showWidgetNew = apply_filters( $FluentChatBasic['nameLower'].'_widget_show', $showWidget);
  if ($showWidgetNew === false) {
    return false;
  }
  $current_user = wp_get_current_user();
  $chatCustomer = new ChatCustomerBasic();
  if ( !ChatOperatorBasic::getSetting('disableOffline') || $chatCustomer->getOnlineOperators() != 0 ) {
    add_filter('body_class', 'FluentChatBasic_AddBodyClass');  
    wp_enqueue_script('jquery');
    wp_enqueue_script('react', plugins_url( 'lib/react'.($FluentChatBasic['env'] == 'live' ? '.min' : '').'.js', __FILE__ ), array('jquery'), 1, true);
    wp_enqueue_script('react-dom', plugins_url( 'lib/react-dom'.($FluentChatBasic['env'] == 'live' ? '.min' : '').'.js', __FILE__ ), array('jquery'), 1, true);

    /* Load MomentJS*/
    wp_enqueue_script('moment', plugins_url( 'lib/moment/moment.min.js', __FILE__ ), array(), 1, true); 
    
    $locale = strtolower(str_replace('_','-',get_locale()));
    $localeLanguage = substr($locale, 0, strpos($locale, '-'));
    if (file_exists(plugin_dir_path( __FILE__ ) . 'lib/moment/locale/'.$locale.'.js')) {
      wp_enqueue_script('moment-'.$locale, plugins_url( 'lib/moment/locale/'.$locale.'.js', __FILE__ ), array(), 1, true); 
    } else if (file_exists(plugin_dir_path( __FILE__ ) . 'lib/moment/locale/'.$localeLanguage.'.js')) {
      wp_enqueue_script('moment-'.$localeLanguage, plugins_url( 'lib/moment/locale/'.$localeLanguage.'.js', __FILE__ ), array(), 1, true);
    }

    wp_enqueue_script($FluentChatBasic['nameLower'].'-frontend', plugins_url( 'dist/chat-front.min.js', __FILE__ ), array('react', 'react-dom'), 1, true);
    wp_localize_script($FluentChatBasic['nameLower'].'-frontend', 'FluentChatBasicTranslate', $FluentChatBasic['translate']);
    wp_localize_script($FluentChatBasic['nameLower'].'-frontend', 'FluentChatBasicGlobals', array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'plugin_dir' => plugins_url('/', __FILE__),
      'dateformat' => get_option('date_format'),
      'timeformat' => get_option('time_format'),      
      'operator' => $current_user->ID,
      'cookie' => $FluentChatBasic['cookieName'],
      'cookieData' => $_COOKIE[$FluentChatBasic['cookieName']],
      'cookiePath' => SITECOOKIEPATH,
      'validKey' => get_site_option($FluentChatBasic['nameLower'].'ValidKey'),
      'haveEmail' => $chatCustomer->getInfo('email'),
      'operatorNickname' => $current_user->display_name,
      'styling' => get_site_option($FluentChatBasic['nameLower'].'Styling'),
      'settings' => get_site_option($FluentChatBasic['nameLower'].'Settings')
    ));
    wp_enqueue_style($FluentChatBasic['nameLower'].'-frontend', plugins_url( 'dist/chat-front.css', __FILE__ ), array(), 1);
  }
}
function FluentChatBasic_AddBodyClass($classes) {
  global $FluentChatBasic;
  $classes[] = 'has-'.$FluentChatBasic['nameLower'];
  return $classes;
}

function FluentChatBasic_FixUploadDirPath($param) {
  global $FluentChatBasic;
  $find = $param['subdir'];
  $replace = '/'.$FluentChatBasic['nameLower'];
  if ($param['subdir'] == '') {
    $param['path'] = rtrim($param['path'],"/").$replace;
    $param['subdir'] = rtrim($param['subdir'],"/").$replace;
    $param['url'] = rtrim($param['url'],"/").$replace;
  } else {
    $param['path'] = rtrim(str_replace($find, $replace, $param['path']),"/");
    $param['subdir'] = rtrim(str_replace($find, $replace, $param['subdir']),"/");
    $param['url'] = rtrim(str_replace($find, $replace, $param['url']),"/");     
  }
  return $param;
}

function FluentChatBasic_Template($replaceArray, $replaceContent) {
  foreach ($replaceArray as $key => $value) {
    $replaceContent = str_replace("[$key]", $value, $replaceContent);
  }
  return $replaceContent;
}

/**********************/
/*** AJAX Functions ***/
/**********************/

add_action('wp_ajax_FluentChatBasic_GetCustomer', 'FluentChatBasic_GetCustomer');
add_action('wp_ajax_nopriv_FluentChatBasic_GetCustomer', 'FluentChatBasic_GetCustomer');
function FluentChatBasic_GetCustomer() {
  $customerID = esc_sql($_GET['customerID']);
  $currentOperator = new ChatOperatorBasic();
  echo json_encode($currentOperator->getCustomerInfo($customerID));
  die();
}

add_action('wp_ajax_FluentChatBasic_ArchiveChat', 'FluentChatBasic_ArchiveChat');
add_action('wp_ajax_nopriv_FluentChatBasic_ArchiveChat', 'FluentChatBasic_ArchiveChat');
function FluentChatBasic_ArchiveChat() {
  global $wp_version, $FluentChatBasic;
  if ( !ctype_digit($_GET['chatID']) ) {
    echo json_encode(array('failed'));
    die();
  }
  $currentCustomer = new ChatCustomerBasic();
  $currentCustomer->archiveChat($_GET['chatID']);
  echo json_encode(array('success' => true));
  die();
}

add_action('wp_ajax_FluentChatBasic_SendContactForm', 'FluentChatBasic_SendContactForm');
add_action('wp_ajax_nopriv_FluentChatBasic_SendContactForm', 'FluentChatBasic_SendContactForm');
function FluentChatBasic_SendContactForm() {
  global $wp_version, $FluentChatBasic; 

  $data = array();
  $settings = get_site_option($FluentChatBasic['nameLower'].'Settings');
  $data[$settings['contactFormNameLabel']] = !empty($_GET['name']) ? $_GET['name'] : '';
  $data[$settings['contactFormEmailLabel']] = !empty($_GET['email']) ? $_GET['email'] : '';
  $data[$settings['contactFormMessageLabel']] = !empty($_GET['message']) ? $_GET['message'] : '';
  $contactFormSubject = FluentChatBasic_Template($data, $settings['contactFormSubject']);
  $contactFormBody = FluentChatBasic_Template($data, $settings['contactFormBody']);
  $contactFormRecipients = strtolower(str_replace(' ', '', $settings['contactFormRecipients']));
  $contactFormRecipients = explode(',', $contactFormRecipients);
  if ( count($contactFormRecipients) == 0 ) {
    echo json_encode(array('failed' => __('No email recipient specified', 'fluentchat')));
    die();
  }
  $headers = array();
  $headers[] = "Reply-To: $name <$email>";
  foreach ($contactFormRecipients as $key => $email) {
    $sent = wp_mail( $email, $contactFormSubject, $contactFormBody, $headers );
  }
  echo json_encode(array('success' => 'true'));
  die();
}

add_action('wp_ajax_FluentChatBasic_EmailTranscript', 'FluentChatBasic_EmailTranscript');
add_action('wp_ajax_nopriv_FluentChatBasic_EmailTranscript', 'FluentChatBasic_EmailTranscript');
function FluentChatBasic_EmailTranscript() {
  global $wp_version, $FluentChatBasic;
  if ( !ctype_digit($_GET['chatID']) ) {
    echo json_encode(array('failed'));
    die();
  }
  $currentCustomer = new ChatCustomerBasic();
  $messages = $currentCustomer->getChatMessages($_GET['chatID'], 0);
  $operator = $currentCustomer->getChatOperatorInfo($_GET['chatID'], 0);
  $operatorName = empty($operatorName) ? 'Operator' : $operatorName;
  $bodyHTML = array();
  foreach ($messages as $key => $message) {
    $temp = array();
    $temp[] = "[".date(get_option('date_format').' '.get_option('time_format'), $message['timestamp'])."]";
    $temp[] = $message['operator'] == 1 ? $operatorName.":" : "You:";
    $temp[] = $message['message'];
    $bodyHTML[] = implode(' ', $temp);
  }
  $bodyHTML = implode("\r\n", $bodyHTML);
  $subject = ChatOperatorBasic::getSetting('allowLogsSubject');
  $headers = array();
  $headers[] = "Reply-To: ".get_bloginfo( 'name' )." <".get_option('admin_email').">";
  $sent = wp_mail( $_GET['email'], $subject, $bodyHTML, $headers );
  if ($sent) {
    $response = array('success' => true);
  } else {
    $response = array('failed' => true);
  }
  echo json_encode($response);
  die();
}

add_action('wp_ajax_FluentChatBasic_UpdateCustomerInfo', 'FluentChatBasic_UpdateCustomerInfo');
add_action('wp_ajax_nopriv_FluentChatBasic_UpdateCustomerInfo', 'FluentChatBasic_UpdateCustomerInfo');
function FluentChatBasic_UpdateCustomerInfo() {
  global $wp_version, $FluentChatBasic;  
   
  $currentCustomer = new ChatCustomerBasic();
  $updateInfo = array('name' => $_GET['name'], 'email' => $_GET['email']);
  $tempValue = apply_filters( $FluentChatBasic['nameLower'].'_customer_update', $updateInfo, $currentCustomer->customerID, 'customer');
  if ($tempValue === false) {
    echo json_encode(array('success' => true));
    die();
  }
  if ($tempValue !== NULL && is_array($tempValue)) {
    $updateInfo = $tempValue;
  }
  $currentCustomer->updateInfo($updateInfo);
  echo json_encode(array('success' => true));
  die();
}

add_action('wp_ajax_FluentChatBasic_UpdateCookie', 'FluentChatBasic_UpdateCookie');
add_action('wp_ajax_nopriv_FluentChatBasic_UpdateCookie', 'FluentChatBasic_UpdateCookie');
function FluentChatBasic_UpdateCookie() {
  global $FluentChatBasic;
  setcookie($FluentChatBasic['cookieName'], $_GET['cookie'], time()+(365 * 24 * 60 * 60 * 10), SITECOOKIEPATH);
}

add_action('wp_ajax_FluentChatBasic_UpdateStateCustomer', 'FluentChatBasic_UpdateStateCustomer');
add_action('wp_ajax_nopriv_FluentChatBasic_UpdateStateCustomer', 'FluentChatBasic_UpdateStateCustomer');
function FluentChatBasic_UpdateStateCustomer() {
  global $wp_version, $FluentChatBasic;
  $lastUpdate = empty($_GET['lastUpdate']) ? 0 : intval($_GET['lastUpdate']);
  $newMessages = array();

  $currentCustomer = new ChatCustomerBasic();

  $response['online'] = $currentCustomer->getOnlineOperators();

  if ( isset($_GET['markChatsRead']) ) {
    foreach ($_GET['markChatsRead'] as $key => $chatID) {
      if (ctype_digit($chatID)) {
        $currentCustomer->markChatRead($chatID);
      }
    }
  }

  if ( isset($_GET['newMessages']) ) {
    foreach ($_GET['newMessages'] as $key => $value) {
      $value = json_decode(stripcslashes($value));
      $newMessages[$value->chatID][] = $value->message;
    }
    foreach ($newMessages as $chatID => $value) {
      $message = json_decode(stripcslashes($value), 1);
      if ($chatID == '0') {
        if ($_GET['autoInit'] && $currentCustomer->activeChats == 0) {
          $chatID = $currentCustomer->recordMessage($chatID, array(ChatOperatorBasic::getSetting('welcomeMessage')), 1);
          $currentCustomer->recordMessage($chatID, $value);
        } else {
          $chatID = $currentCustomer->recordMessage($chatID, $value);
        }
        $response['meta']['NewChatCreated'] = $chatID;
      } else {
        $currentCustomer->recordMessage($chatID, $value);
      }
      if ($currentCustomer->getChatOperatorInfo($chatID) == false) {
        $currentCustomer->sendSMS($value);
      }
    }
  }

  $getMessages = $currentCustomer->getChats($lastUpdate);

  $response['newLastUpdate'] = strtotime('now');
  $response['activeChats'] = $getMessages;
  echo json_encode($response);
  die();
}

add_action('wp_ajax_FluentChatBasic_ArchiveChatOperator', 'FluentChatBasic_ArchiveChatOperator');
function FluentChatBasic_ArchiveChatOperator() {
  global $wp_version, $FluentChatBasic;
  if ( !ctype_digit($_GET['chatID']) ) {
    echo json_encode(array('failed'));
    die();
  }
  $currentOperator = new ChatOperatorBasic();
  $currentOperator->archiveChat($_GET['chatID']);
  echo json_encode(array('success' => true));
  die();
}

add_action('wp_ajax_FluentChatBasic_GetOperatorProfile', 'FluentChatBasic_GetOperatorProfile');
function FluentChatBasic_GetOperatorProfile() {
  global $wp_version, $FluentChatBasic;
  $currentOperator = new ChatOperatorBasic();
  $response = $currentOperator->getProfile();
  $weekDays = array('sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday');
  foreach ($weekDays as $key => $value) {
    $response[$value] = intval($response[$value]);
    $response[$value.'from'] = intval($response[$value.'from']);
    $response[$value.'to'] = intval($response[$value.'to']);
  }
  echo json_encode($response);
  die();
}

add_action('wp_ajax_FluentChatBasic_GetArchivedChats', 'FluentChatBasic_GetArchivedChats');
function FluentChatBasic_GetArchivedChats() {
  global $wp_version, $FluentChatBasic;
  $currentOperator = new ChatOperatorBasic();
  $limit = intval($_GET['pageSize']);
  $offset = intval($_GET['pageSize'])*(intval($_GET['page'])-1);
  $meta = array();
  if ( !empty($_GET['search']) ) {
    $meta['search'] = $_GET['search'];
  }
  if (ChatOperatorBasic::isAdmin($currentOperator->ID)) {
    $operator = empty($_GET['operator']) ? 0 : $_GET['operator'];
  } else {
    $operator = 'self';
  }
  $activeChats = $currentOperator->getOperatorChats($operator, 0, 0, 1, $limit, $offset, $meta);
  foreach ($activeChats['data'] as $key => $value) {
    $activeChats['data'][$key]['operatorInfo'] = $currentOperator->getOperatorInfo($value['operators']);
    $activeChats['data'][$key]['feedback'] = $currentOperator->getChatRating($value['chat_id']);
    $activeChats['data'][$key]['count'] = $currentOperator->getChatMessageCount($value['chat_id']);
  }
  echo json_encode(array('success' => true, 'count' => $activeChats['count'], 'data' => $activeChats['data']));
  die();
}

add_action('wp_ajax_FluentChatBasic_GetChatMessages', 'FluentChatBasic_GetChatMessages');
function FluentChatBasic_GetChatMessages() {
  global $wp_version, $FluentChatBasic;
  $chatID = intval($_GET['chatID']);
  $currentOperator = new ChatOperatorBasic();
  $response = $currentOperator->getChatMessages($chatID, 0);
  echo json_encode(array('success' => true, 'chat' => $response));
  die();
}

add_action('wp_ajax_FluentChatBasic_UpdateStateOperator', 'FluentChatBasic_UpdateStateOperator');
function FluentChatBasic_UpdateStateOperator() {
  global $wp_version, $FluentChatBasic;
  $lastUpdate = empty($_GET['lastUpdate']) ? 0 : intval($_GET['lastUpdate']);
  $newMessages = array();

  $currentOperator = new ChatOperatorBasic();
  if ( isset($_GET['markChatsRead']) ) {
    foreach ($_GET['markChatsRead'] as $key => $value) {
      if (ctype_digit($value)) {
        $currentOperator->markChatRead($value);
      }
    }
  }
  if ( isset($_GET['newMessages']) ) {
    foreach ($_GET['newMessages'] as $key => $value) {
      $value = json_decode(stripcslashes($value));
      if (ctype_digit($value->chatID)) {
        $currentOperator->recordMessage($value->chatID, $value->message);
      }
    }
  }
  $tempA = $currentOperator->getUnassignedChats($lastUpdate, 1);
  $tempB = $currentOperator->getOperatorChats('self', $lastUpdate, 1, 0, 9999, 0);
  $activeChatsTemp = array_merge($tempA['data'], $tempB['data']);
  foreach ($activeChatsTemp as $key => $value) {
    $activeChats[$value['chat_id']] = $value;
  }
  $response['newLastUpdate'] = strtotime('now');
  $response['activeChats'] = $activeChats;
  echo json_encode($response);
  die();
}

add_action('wp_ajax_FluentChatBasic_TestNumber', 'FluentChatBasic_TestNumber');
function FluentChatBasic_TestNumber() {
  global $wpdb, $FluentChatBasic;
  if ( empty($_GET['number']) ) {
    $response['failed'] = __('Mobile number can\'t be empty', 'fluentchatbasic');
    echo json_encode($response); die();
  }
  if ( empty($_GET['carrier']) ) {
    $response['failed'] = __('Mobile carrier can\'t be empty', 'fluentchatbasic');
    echo json_encode($response); die();
  }
  $headers[] = "From: ".$FluentChatBasic['nameCamel']." <".get_option('admin_email').">";
  $email = str_replace('[number]', $_GET['number'], $_GET['carrier']);
  $message = 'Test SMS from '.$FluentChatBasic['nameCamel'];
  $sendSMS = wp_mail( $email, '', $message, $headers );
  if ($sendSMS) {
    $response['success'] = __('SMS sent to ', 'fluentchat').$_GET['number'];
    echo json_encode($response); die();
  }
}

add_action('wp_ajax_FluentChatBasic_UpdateSettings', 'FluentChatBasic_UpdateSettings');
function FluentChatBasic_UpdateSettings() {
  global $wpdb, $FluentChatBasic;

  if (get_site_url() == 'http://ncrafts.net/fluent-chat/demo') {
    $response['failed'] = __('Changes to settings can\'t be saved on demo site', 'fluentchatbasic');
    echo json_encode($response);
    die();    
  }

  $styling = empty($_POST['styling']) ? '{}' : json_decode(stripcslashes($_POST['styling']), 1);
  $settings = empty($_POST['settings']) ? '{}' : json_decode(stripcslashes($_POST['settings']), 1);
  $operatorsList = empty($_POST['operatorsList']) ? '{}' : json_decode(stripcslashes($_POST['operatorsList']), 1);
  update_site_option($FluentChatBasic['nameLower'].'Styling', $styling);
  update_site_option($FluentChatBasic['nameLower'].'Settings', $settings);
  $currentOperator = new ChatOperatorBasic();
  if (count($operatorsList) > 0) {
    foreach ($operatorsList as $ID => $operator) {
      $currentOperator->updateOperator($ID, $operator['canAdmin'], $operator['canOperator']);
    }
  }
  // delete_site_option($FluentChatBasic['nameLower'].'Styling');
  // delete_site_option($FluentChatBasic['nameLower'].'Settings');
  $response['success'] = __('Changed saved', 'fluentchatbasic');
  echo json_encode($response);
  die();
}

function FluentChatBasic_GetDomain($url)
{
  $pieces = parse_url($url);
  $domain = isset($pieces['host']) ? $pieces['host'] : '';
  if (preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
    return $regs['domain'];
  }
  return false;
}

add_action('wp_ajax_FluentChatBasic_UpdateOperator', 'FluentChatBasic_UpdateOperator');
function FluentChatBasic_UpdateOperator() {
  global $wpdb, $FluentChatBasic;
  $info = json_decode(stripcslashes($_POST['operator']), 1);
  $current_user = wp_get_current_user();
  $weekDays = array('sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday');
  $saveObject = array();
  $saveObject['fullname'] = esc_sql($info['fullname']);
  $saveObject['nickname'] = esc_sql($info['nickname']);
  $saveObject['email'] = esc_sql($info['email']);
  $saveObject['job_title'] = esc_sql($info['job_title']);
  $saveObject['description'] = esc_sql($info['description']);
  $saveObject['canned'] = esc_sql(json_encode($info['canned']));
  $saveObject['image'] = esc_sql($info['image']);

  foreach ($weekDays as $key => $value) {
    $saveObject[$value] = empty($info[$value]) ? false : true;
    $saveObject[$value.'from'] = empty($info[$value.'from']) ? 0 : intval($info[$value.'from']);
    $saveObject[$value.'to'] = empty($info[$value.'to']) ? 0 : intval($info[$value.'to']);
  }

  $wpdb->update($FluentChatBasic['operatorsTable'], $saveObject, array('operator_id'=>$current_user->ID));
  return true;
  die();
}

add_action('wp_ajax_FluentChatBasic_UpdateCustomer', 'FluentChatBasic_UpdateCustomer');
function FluentChatBasic_UpdateCustomer() {
  global $wpdb, $FluentChatBasic;
  $customerID = esc_sql($_GET['customerID']);
  $customerInfo = json_decode(stripcslashes($_GET['customerInfo']), 1);
  $saveObject = array();
  $current_user = wp_get_current_user();
  if ( !empty($customerInfo['newNotes']) ) {
    foreach ($customerInfo['newNotes'] as $key => $value) {
      $customerInfo['notes'][] = array(
        'operator' => $current_user->display_name,
        'created' => strtotime('now'),
        'body' => $value
      );
    }
  }
  $saveObject['name'] = esc_sql($customerInfo['name']);
  $saveObject['email'] = esc_sql($customerInfo['email']);
  $saveObject['location'] = esc_sql($customerInfo['location']);
  $saveObject['ip'] = esc_sql($customerInfo['ip']);
  $saveObject['browser'] = esc_sql($customerInfo['browser']);
  $saveObject['notes'] = json_encode($customerInfo['notes']);
  $saveObject['last'] = strtotime('now');
  $tempValue = apply_filters( $FluentChatBasic['nameLower'].'_customer_update', $saveObject, $customerID, 'operator');
  if ($tempValue === false) {
    echo json_encode(array('success' => true));
    die();
  }
  if ($tempValue !== NULL && is_array($tempValue)) {
    $saveObject = $tempValue;
  }
  $saved = $wpdb->update($FluentChatBasic['customersTable'], $saveObject, array('customer_id'=>$customerID));
  if ($saved) {
    $response['success'] = $saved;
  } else {
    $response['failed'] = true;
  }
  echo json_encode($response);
  die();
}

?>
